<?php
	
	function cmp($pwd, $hash) {
		return strcmp(crypt($pwd, $hash), $hash) == 0;
	}
	
	class UserDBHtpasswd implements IUsers {
		private $users = array();
		private $cmpFunc;
		
		public function __construct($file, $cmpFunc) {
			$this->cmpFunc = $cmpFunc;
			
			if (!file_exists($file)) throw new Exception("file $file does not exist, can't load user db");
			$lines = file($file, FILE_IGNORE_NEW_LINES | FILE_SKIP_EMPTY_LINES);
			foreach ($lines as $line) {
				$cmdbeg = strpos($line, '#');
				if ($cmdbeg !== false) {
					if ($cmdbeg == 0) return;
					$line = substr($line, $cmdbeg);
				}
				$line = trim($line);
				if (strlen($line) == 0) return;
				
				$delim = strpos($line, ':');
				if ($delim === false || $delim == 0 || $delim == strlen($line) - 1) return;
				$this->users[substr($line, 0, $delim)] = substr($line, $delim + 1);
			}
		}
		
		public function authenticate($user, $pwd) {
			if (!array_key_exists($user, $this->users)) return false;
			return call_user_func($this->cmpFunc, $pwd, $this->users[$user]);
		}
		
		public function getUsers() {
			return array_keys($this->users);
		}
		
		public function isAdmin($user) {
			return false;
		}
	}
	
?>