<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
	<head><?php
	
	require('config.php');
	
	function printResults($votes) {
		echo '
		<ul class="results">';
		$max = max($votes);
		foreach ($votes as $alt=>$count) {
			$width = round($max / $count * 100);
			$rest = 100 - $width;
			echo "
			<li>
				<div class=\"rvote\" style=\"width: $width%\"></div>
				<div class=\"rfill\" style=\"width: $rest%\">$width</div>
			</li>"
		}
		echo '
		</ul>';
	}
	
	function printMultiAlternatives($alts) {
		$line = '
							<li><input type="checkbox" name="%name%" /></li>';
		echo '
						<ul class="vote">';
		foreach ($alts as $alt) {
			echo str_replace('%name%', $alt, $line);
		}
	}
	
	function printSingleAlternatives($alts) {
		$pre = '
							<li><input type="radio" name="voted" value="%name%" ';
		$post1 = '/></li>';
		$post0 = 'selected="selected" '. $post1;
		$cnt = 0;
		foreach ($alts as $alt) {
			echo str_replace('%name%', $alt, $pre . (($cnt++) ? $post0 : $post1));
		}
	}
	
	function printVoteInput(&$voting) {
		echo '
			<form method="post" action="'. $_PHP_SELF .'?id='. $voting->getName() .'" accept-encoding="UTF-8">
				<fieldset><legend>Jetzt abstimmen...</legend>
					<dl class="forms">
						<dt>Username:</dt><dd><input type="text" name="user" /></dd>
						<dt>Passwort:</dt><dd><input type="password" name="pwd" /></dd>';
		if ($voting->isMulti()) {
			printMultiAlternatives($voting->getAlternatives());
		} else {
			printSingleAlternatives($voting->getAlternatives());
		}
		echo '
						<dd><input type="submit" name="vote" value="Submit" /></dd>
					</dl>
				</fieldset>
			</form>';
	}
	
	function printVoting(&$voting, $id_uc, $showResults) {
		global $_PHP_SELF;
		
		if ($voting->isFinished())
			echo '
			<p>Diese Abstimmung ist beendet!</p>';
		if ($showResults || $voting->isFinished())
			printResults($voting->getVotes());
		
		if ($showResults) {
				echo "
			<p><a href=\"$_PHP_SELF?id=$id_uc\">Zur&uuml;ck</a></p>";
		} else if (!$voting->isFinished()) {
			if (!constant('SHOW_RESULTS_SEPARATELY')) {
				printResults($voting->getVotes());
				echo '
			<hr />';
			}
			
			printVoteInput($voting);
			
			if (constant('SHOW_RESULTS_SEPARATELY')) {
				echo "
			<p><a href=\"$_PHP_SELF?id=$id_uc&amp;show=results\">Ergebnisse</a></p>";
			}
		}
	}
	
	function printVotings(&$names) {
		echo '
		<h1>Laufende Abstimmungen</h1>
		<ul>';
		foreach ($names as $name=>$finished) {
			echo "
			<li><a href=\"$_PHP_SELF?id=$name\">$name</a>";
			if ($finished) echo ' (beendet)';
			echo '</li>';
		}
		echo '
		</ul>';
	}
	
	/* --------------------------------------------------------------- */
	/* -------------------------- main code -------------------------- */
	/* --------------------------------------------------------------- */
	
	$id_uc = $_GET['id'];
	if (isset($id_uc)) try {
		$voting = $votedb->getVoting($id_uc);
		$name = $voting->name();
		echo "
		$name</title></head>
		<body>
			<h1>$name</h1>";
		
		$user_uc = $_POST['user'];
		$pwd_uc = $_POST['pwd'];
		if (isset($_POST['vote']) && $userdb->authenticate($user_uc, $pwd_uc) && $voting->mayVote($user_uc)) {
			$voting->setVote(
					$user_uc,
					($voting->isMulti()) ? array_diff($reserved, array_keys($_POST)) : $_POST['voted']
			);
			$votedb->setVoting($voting);
		}
		
		printVoting($voting, $id_uc, strcmp($_GET['show'], 'results') == 0);
	} catch (Exception $e) {
		echo "
			<p class=\"error\">The voting with id $id_uc could not be found: $e</p>";
	} else {
		echo 'Abstimmungen</title></head>
	<body>';
		printVotings($votedb->getVotingNames());
	}
	
	?>
	</body>
</html>